unit cDL810_Head;

interface

Const
    COM1 = 1;
    COM2 = 2;
    COM3 = 3;
    COM4 = 4;
    COM5 = 5;
    COM6 = 6;
    COM7 = 7;
    COM8 = 8;
    COM9 = 9;
    COM10 = 10;


    OK			    	= $00;
    LengthError         = $01;
    OperationNotSupport = $02;
    DataRangError       = $03;
    CmdNotOperation     = $04;
    RfClosed            = $05;
    EEPROM              = $06;
    TimeOut             = $0a;
    MoreUID             = $0b;
    ISOError            = $0c;
    NoElectronicTag     = $0e;
    OperationError      = $0f;

    CmdNotSupport                 = $01;
    CmdNotIdentify                = $02;
    OperationNotSupport_          = $03;
    UnknownError                  = $0f;
    BlockError                    = $10;
    BlockLockedAndCntLock         = $11;
    BlockLockedAndCntWrite        = $12;
    BlockCntOperate               = $13;
    BlockCntLock                  = $14;

    CommunicationErr = $30;
    RetCRCErr        = $31;
    RetDataErr       = $32;    //ݳд
    CommunicationBusy= $33;
    ExecuteCmdBusy   = $34;
    ComPortOpened    = $35;
    ComPortClose     = $36;
    InvalidHandle    = $37;
    InvalidPort      = $38;


    Function DL810_GetBlockSize_BlockNum(Firmcode,OtherCode : Byte;
                                          Var FirmName : String;
                                          Var BlockSize,BlockNum : Byte;
                                          Var BlockStyle : String) : Boolean;
    Function DL810_GetErrorCodeDesc(errorCode : Byte) : String;
    Function DL810_GetReturnCodeDesc(retCode : Byte) : String;

implementation

{//2006-8-2
	̴	Ϣ	д					  A	B
Infineon (ISO Address mode)	0x05			256(ûΧ0249)	4ֽ	    -	  
							64 (ûΧ057)	4ֽ	    -	  
STMicroelectronics (LRI512)	0x02			16(ûΧ0~15)	4ֽ	    -	  
Fujitsu (MB89R116)	        0x08			256(ûΧ0249)	8ֽ	    	  
Philips (I-Code SLI)		0x04			32(ûΧ027)	4ֽ	    -	  
Texas Instruments (Tag-it HF-I)	0x07			64(ûΧ063)	4ֽ	    	  -
EM Microelectronic  (EM4034-)   0X16			14(ûΧ3-13)        4ֽ
}
Function DL810_GetBlockSize_BlockNum(Firmcode,OtherCode : Byte;
                                      Var FirmName : String;
                                      Var BlockSize,BlockNum : Byte;
                                      Var BlockStyle : String) : Boolean;
Begin
   result := true;
   case FirmCode of
       $05 :
           Begin
               FirmName := 'Infineon';   //(ISO Address mode)
               BlockSize:= 4;
               BlockNum := 58;
               if OtherCode=$E0 then BlockNum := 250
               else if OtherCode=$60 then BlockNum := 58;

               BlockStyle := 'B';   //B
           end;
       $02 :
           Begin
               FirmName := 'STMicroelectronics';   //(LRI512)
               BlockSize:= 4;
               BlockNum := 16;

               BlockStyle := 'B';   //B
           end;
       $08 :
           Begin
               FirmName := 'Fujitsu';    //(MB89R116)
               BlockSize:= 8;
               BlockNum := 250;

               BlockStyle := 'AB';   //AB
           end;
       $04 :
           Begin
               FirmName := 'Philips Semiconductors';   //(I-Code SLI)
               BlockSize:= 4;
               BlockNum := 28;

               BlockStyle := 'B';   //B
           end;
       $07 :
           Begin
               FirmName := 'Texas Instruments';   //(Tag-itHF-I)
               BlockSize:= 4;
               BlockNum := 64;

               BlockStyle := 'A';   //A
           end;
     //-------------------------------------------------------------------------
      $16 :                           //FirmCode $16
                                       //2006-8-2 ޸ļ'EM Microelectronic '
            begin
              FirmName := 'EM Microelectronic '  ;  //
              BlockSize:= 4;                      //    ??
              BlockNum := 14;                     // ??
              BlockStyle := 'A';              //AB//??
            end;
        //------------------------------------------- --------------------------
       else
           result := False;
   end;
end;

Function DL810_GetErrorCodeDesc(errorCode : Byte) : String;
begin
  result := '';
  case errorCode of
    CmdNotSupport         : result := 'Commands  not supported';
    CmdNotIdentify        : result := 'Unknown Command ';
    OperationNotSupport_  : result := 'Operation not supported';
    UnknownError          : result := 'Unknown error ';
    BlockError            : result := 'Appointed  block cant be used or does not exist';
    BlockLockedAndCntLock : result := 'Appointed  block is locked and cant be locked again.';
    BlockLockedAndCntWrite: result := 'Appointed  block is locked and its content can not be altered';
    BlockCntOperate       : result := 'Appointed  block cant be operated normally';
    BlockCntLock          : result := 'Appointed  block cant be locked normally';
    CmdNotOperation      :  result := 'CMD can' + 't execute at current ';
  end;
end;

Function DL810_GetReturnCodeDesc(retCode : Byte) : String;
begin
  result := '';
  case retCode of
     LengthError         : result := 'Command operand length error';
     OperationNotSupport : result := ' Command not supported';
     RfClosed            : result := 'RF field is inactive';
     EEPROM              : result := 'EEPROM operation error';
     TimeOut             : result := 'Inventory-Scan-Time overflow';
     MoreUID             : result := 'Not all tag''''s UIDs are collected before the Inventory-Scan-Time overflow';
     ISOError            : result := 'ISO error';        //ISO error
     NoElectronicTag     : result := 'No  Tags';
     OperationError      : result := 'Operation error';
     CommunicationErr    : result := 'Communication Error';
     RetCRCErr           : result := 'CRC checksummat Error';
     RetDataErr          : result := '';
     CommunicationBusy   : result := 'Communication busy';
     CmdNotOperation     : result := 'CMD can' +'''+t execute at current ';
     DataRangError       : result := 'Operation data range error';
  end;
end;

end.
